%define majorkik       16
%define libnamekik     %mklibname kik %{majorkik}
%define majormkf       16
%define libnamemkf     %mklibname mkf %{majormkf}

%define _disable_ld_no_undefined 1

Summary:        Multi Lingual TERMinal emulator for X
Name:           mlterm
Version:        3.9.3
Release:        %mkrel 1
License:        BSD style
Group:          Terminals
URL:            https://mlterm.sourceforge.net/
Source0:        https://prdownloads.sourceforge.net/mlterm/mlterm-%{version}.tar.gz
Patch0:         disable_rpath.diff
# https://github.com/arakiken/mlterm/commit/f971955cf54a721e6a53191c3b86fbdab4bfbfd5
Patch1:         mlterm-gcc14-f971955.patch
# https://github.com/arakiken/mlterm/commit/3d38b723e0e4a6dd434af2d49aca53890982a828
Patch2:         mlterm-gcc14-3d38b72.patch
# https://github.com/arakiken/mlterm/commit/08ba9859717ed27384675bd687a35f4504701f27
Patch3:         mlterm-gcc14-08ba985.patch
# https://github.com/arakiken/mlterm/commit/8aef4fae3add8e8acfafde831e0034f1b2879dea
Patch4:         mlterm-gcc14-8aef4fa.patch
# https://github.com/arakiken/mlterm/commit/20ab931d5055dc5835154a75ca672fade478549f
Patch5:         mlterm-gcc14-20ab931.patch
# https://github.com/arakiken/mlterm/commit/79f4b0883dc62af26a9afb2c26dc4a068c2a7f9e
Patch6:         mlterm-gcc14-79f4b08.patch

BuildRequires:  ccache
BuildRequires:  imagemagick
BuildRequires:  canna-devel
BuildRequires:  coreutils
BuildRequires:  scim-devel
BuildRequires:  uim-devel
BuildRequires:  utempter-devel
BuildRequires:  pkgconfig(cairo)
BuildRequires:  pkgconfig(fcitx)
BuildRequires:  pkgconfig(fontconfig)
BuildRequires:  pkgconfig(fribidi)
BuildRequires:  pkgconfig(gail)
BuildRequires:  pkgconfig(gdk-pixbuf-2.0)
BuildRequires:  pkgconfig(gtk+-3.0)
BuildRequires:  pkgconfig(gtk4)
BuildRequires:  pkgconfig(harfbuzz)
BuildRequires:  pkgconfig(ibus-1.0)
BuildRequires:  pkgconfig(libssh2)
BuildRequires:  pkgconfig(m17n-core)
BuildRequires:  pkgconfig(vte-2.91)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xkbcommon)
Requires:       ncurses-extraterms
Obsoletes:      %libnamekik <= %{version}-%{release}
Obsoletes:      %libnamemkf <= %{version}-%{release}

%description
mlterm is a multi-lingual terminal emulator written from
scratch, which supports various character sets and encodings
in the world.  It also supports various unique feature such as
anti-alias using FreeType, multiple windows, scrollbar API,
scroll by mouse wheel, automatic selection of encoding,
and so on. Multiple xims are also supported.
You can dynamically change various xims.
NOTE: mlterm has good config tools.
Press Ctrl + right click or Ctrl + left click to run them.

%package canna
Summary:        Canna plugin for mlterm
Group:          Terminals
Provides:       locale(scim:ja;ko;ar;he)

%description canna
A plugin to use the canna input methods directly from mlterm.

%package ibus
Summary:        Ibus plugin for mlterm
Group:          Terminals
Provides:       locale(scim:ja;ko;ar;he)

%description ibus
A plugin to use the ibus input methods directly from mlterm.

%package scim
Summary:        SCIM plugin for mlterm
Group:          Terminals
Provides:       locale(scim:ja;ko;ar;he)

%description scim
A plugin to use the SCIM input methods directly from mlterm.

%package uim
Summary:        An uim plugin for mlterm
Group:          Terminals
Provides:       locale(uim:ja;ko;ar;he)

%description uim
A plugin to use the uim input methods directly from mlterm.

%package m17n
Summary:        A m17n plugin for mlterm
Group:          Terminals
Provides:       locale(m17n:ja;ko;zh;ar;he)

%description m17n
A plugin to use the m17n input methods directly from mlterm.


%prep
%autosetup -p1

%build
%configure \
        --disable-static \
        --disable-utmp \
        --enable-anti-alias \
        --enable-fribidi \
        --enable-ssh2 \
        --enable-vt52 \
        --enable-ind \
        --enable-m17nlib \
        --enable-ibus \
        --disable-fcitx \
        --enable-canna \
        --enable-scim \
        --enable-uim \
        --disable-rpath \
        --with-gtk=4.0 \
        --with-tools=mlclient,mlcc,mlfc,mlmenu,mlterm-zoom,mlimgloader,mlconfig \
        --with-scrollbars=sample,extra,pixmap_engine \
        --with-type-engines=xcore,xft,cairo \
        --with-imagelib=gdk-pixbuf \
        --enable-optimize-redrawing

%make_build

%install
%make_install

install -m 644 contrib/tool/mlterm-menu/menu %{buildroot}%{_sysconfdir}/mlterm/
install -D -m644 "contrib/icon/%{name}-icon.svg" \
  "%{buildroot}%{_iconsdir}/hicolor/scalable/apps/%{name}.svg"
install -D -m644 "contrib/icon/%{name}-icon-trans.svg" \
  "%{buildroot}%{_iconsdir}/hicolor/scalable/apps/mlclient.svg"

# install menu entry.
mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/%{_real_vendor}-%{name}.desktop <<EOF
[Desktop Entry]
Name=Mlterm
Comment=A multi-lingual terminal emulator
Exec=%{name}
Icon=%{name}
Terminal=false
Type=Application
StartupNotify=false
Categories=System;TerminalEmulator;
EOF

# remove unnecessary files
find %{buildroot} -name "*.la" -delete

%files
%doc ChangeLog README doc/{en,ja}
%license LICENCE
%config(noreplace) %{_sysconfdir}/mlterm/
%{_bindir}/mlcc
%{_bindir}/mlclient
%{_bindir}/mlterm
%{_bindir}/mlclientx
%{_bindir}/mlfc
%dir %{_libdir}/%{name}/
%{_libdir}/libmef.so*
%{_libdir}/libpobl.so*
%{_libdir}/libmlterm_coreotl.so
%{_libdir}/mef/
%{_libdir}/%{name}/*.so
%exclude %{_libdir}/mlterm/libim-canna.so
%exclude %{_libdir}/mlterm/libim-ibus.so
%exclude %{_libdir}/mlterm/libim-scim.so
%exclude %{_libdir}/mlterm/libim-uim.so
%exclude %{_libdir}/mlterm/libim-m17nlib.so

%{_libexecdir}/%{name}/
%{_datadir}/%{name}/
%{_mandir}/man1/*
%{_datadir}/applications/%{_real_vendor}-%{name}.desktop
%{_iconsdir}/hicolor/scalable/apps/*.svg

%files canna
%{_libdir}/mlterm/libim-canna.so

%files ibus
%{_libdir}/mlterm/libim-ibus.so

%files scim
%{_libdir}/mlterm/libim-scim.so

%files uim
%{_libdir}/mlterm/libim-uim.so

%files m17n
%{_libdir}/mlterm/libim-m17nlib.so


%changelog
* Thu Oct 17 2024 daviddavid <daviddavid> 3.9.3-1.mga10
+ Revision: 2107763
- new version: 3.9.3
- backport some upstream GCC 14 build fixes
- enable gtk4 support

* Tue Apr 05 2022 umeabot <umeabot> 3.9.1-2.mga9
+ Revision: 1845159
- Mageia 9 Mass Rebuild

* Sat Nov 06 2021 joequant <joequant> 3.9.1-1.mga9
+ Revision: 1754110
- update to 3.9.1

* Thu Feb 13 2020 umeabot <umeabot> 3.3.8-7.mga8
+ Revision: 1515172
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x
- replace deprecated %%makeinstall_std

* Sun Sep 23 2018 umeabot <umeabot> 3.3.8-6.mga7
+ Revision: 1299572
- Mageia 7 Mass Rebuild

* Fri Jan 29 2016 umeabot <umeabot> 3.3.8-5.mga6
+ Revision: 928846
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 3.3.8-4.mga5
+ Revision: 746961
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 3.3.8-3.mga5
+ Revision: 727338
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 3.3.8-2.mga5
+ Revision: 682548
- Mageia 5 Mass Rebuild

* Mon Aug 25 2014 blino <blino> 3.3.8-1.mga5
+ Revision: 667361
- 3.3.8

* Sun Jun 15 2014 wally <wally> 3.3.6-3.mga5
+ Revision: 636534
- build cairo engine

* Sun Jun 15 2014 wally <wally> 3.3.6-2.mga5
+ Revision: 636439
- add fixes from usptream (patch updated 2014-06-07)

* Sun Jun 15 2014 wally <wally> 3.3.6-1.mga5
+ Revision: 636434
- new version 3.3.6
- rediff font and main config patches
- add 'lib major check' to files section
- drop explicit lib pkg requires from main pkg
+ blino <blino>
- package mlimgloader (in libexec)
- drop merged strfmt patch

* Sat Jan 12 2013 umeabot <umeabot> 3.0.0-5.mga3
+ Revision: 360172
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Dec 25 2012 wally <wally> 3.0.0-4.mga3
+ Revision: 334949
- redo linking patch
+ dams <dams>
- clean specfile

* Thu Jan 20 2011 blino <blino> 3.0.0-3.mga1
+ Revision: 27362
- use _real_vendor for desktop file name
- remove old ldconfig scriptlets
- imported package mlterm


* Mon Dec 06 2010 Oden Eriksson <oeriksson@mandriva.com> 3.0.0-2mdv2011.0
+ Revision: 612872
- the mass rebuild of 2010.1 packages

* Sun Apr 25 2010 Funda Wang <fwang@mandriva.org> 3.0.0-1mdv2010.1
+ Revision: 538658
- New version 3.0.0
- fix linkage

  + Jérôme Brenier <incubusss@mandriva.org>
    - use %%configure2_5x
    - fix str fmt (P2)

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild

  + Oden Eriksson <oeriksson@mandriva.com>
    - lowercase ImageMagick

* Tue Nov 11 2008 Funda Wang <fwang@mandriva.org> 2.9.4-3mdv2009.1
+ Revision: 302071
- revert to configure as 2_5x breaks x86_64 build
- use configure2_5x

* Tue Jul 29 2008 Thierry Vignaud <tv@mandriva.org> 2.9.4-3mdv2009.0
+ Revision: 252611
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Pixel <pixel@mandriva.com>
    - rpm filetriggers deprecates update_menus/update_scrollkeeper/update_mime_database/update_icon_cache/update_desktop_database/post_install_gconf_schemas
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Thu Dec 13 2007 Jérôme Soyer <saispo@mandriva.org> 2.9.4-1mdv2008.1
+ Revision: 119233
- New release 2.9.4

* Mon Oct 01 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.9.3-3mdv2008.0
+ Revision: 94090
- Rebuild for fixed package changelog.

* Mon Oct 01 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.9.3-2mdv2008.0
+ Revision: 94081
- Rebuild (#34355).
- Bunzip patches.
- Install binaries at /usr/bin, not /usr/X11R6/bin (#34324).
- Switch to xdg menu.

  + Jérôme Soyer <saispo@mandriva.org>
    - import mlterm


* Mon May 15 2006 Jerome Soyer <saispo@mandriva.org> 2.9.3-1mdk
- New release 2.9.3

* Wed Apr 19 2006 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 2.9.2-3.20060419.1mdk
- latest snapshot
- remove buildrequires gtk-devel
- add configure options (--disable-rpath)

* Wed Feb 08 2006 Thierry Vignaud <tvignaud@mandriva.com> 2.9.2-2mdk
- use mkrel
- drop explicit dependancy already cautgh by autodeps
- fix conflict with ncurses-extraterms (#18482)

* Tue May 10 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.9.2-1mdk
- fix build with new rpm
- UTUMI Hirosi <utuhiro78@yahoo.co.jp>:
  o new release
  o update font config (patch0) for new sung (a new chinese font)
  o fix requires (mlterm needs libkik and libmkf)

* Wed Dec 29 2004 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 2.9.1-2.cvs20041229.1mdk
- latest snapshot
- remove --enable-uim (unstable)
- update patch0, patch1

* Tue Nov 30 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.9.1-1mdk
- bump major
- UTUMI Hirosi <utuhiro78@yahoo.co.jp>:
  o new release
  o add '# install terminfo'
  o update patch11 (fix font settings)

* Wed Sep 29 2004 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 2.8.0-2.cvs20040929.1mdk
- cvs20040929
- add patch11
- add --enable-uim
- modify %%description

* Tue Jun 29 2004 Abel Cheung <deaddog@deaddog.org> 2.8.0-1mdk
- New version
- Build with bidi support
- Eliminate bogus devel packages, no other software ever links
  with the libraries, and devel files are just created as a
  libtool side effect
- P0: 2.8.0 patch level 1
- P10: Eliminate rpath from binaries

* Thu Jun 03 2004 Michael Scherer <misc@mandrake.org> 2.7.0-3mdk 
- rebuild for new libintl
- quiet setup
- use mklibname

* Wed Feb 25 2004 Lenny Cartier <lenny@mandrakesoft.com> 2.7.0-2mdk
- fix DIRM

* Wed Aug 06 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.7.0-1mdk
- 2.7.0
- split

* Sun Mar 24 2002 DU Xiaoming <dxiaoming@mandrakesoft.com> 2.3.1-1mdk
- First version for Linux-Mandrake.
